// grille.cc
// T Feil
// ECNA 2015

#include <iostream>
using namespace std;
 
// globals
int n, m;
//char E[101], Message[101];
char Message[101];
string E;
char Grille[10][10];

// ***************

void GetGrille(){
  for (int i=0;i<n;i++)
    for (int j=0;j<n;j++)
      cin>>Grille[i][j];
}

// ***************

int GetMessage(){
  cin>>E;
//  return strlen(E);
  return E.length();
}

// ***************

void RotateGrille(){
  char Temp[n][n];
  
  for(int i=0;i<n;i++)
    for(int j=0;j<n;j++)
      Temp[j][n-i-1] = Grille[i][j];
  //copy Temp -> Grille
  for(int i=0;i<n;i++)
    for(int j=0;j<n;j++)
      Grille[i][j] = Temp[i][j];
}

// ***************

void DoGrille(){
  int q, r;         // r = position in E, q =pos in Message

  r=0;
  for (int x=0;x<4;x++){     // 4 rotations of Grille
    q = 0;
    for(int i=0;i<n;i++)
      for (int j=0;j<n;j++){
        if (Grille[i][j] == '.')  // put this letter in the Message
          Message[q] = E[r++];
        q++; 
      }
    RotateGrille();
  }
} 

// ***************

bool GrilleOK(){
  int A[n][n];       //counts

  for(int i=0;i<n;i++)
    for (int j=0;j<n;j++)
      A[i][j] = 0;

  for (int x=0;x<4;x++){    //rotate 4 times, count holes
    for(int i=0;i<n;i++)
      for (int j=0;j<n;j++)
        if (Grille[i][j] == '.')
          A[i][j]++;
    RotateGrille();
  }
  // check each spot exactly once
  bool ok = true;
  for(int i=0;i<n;i++)
    for (int j=0;j<n;j++)
      if (A[i][j] != 1)
        ok = false;
  
  return ok;
}

// ***************

int main(){

  cin>>n;

    GetGrille();
    m = GetMessage();    // E

    if (GrilleOK()){
      DoGrille();
      for (int i=0;i<m;i++) cout<<Message[i];
      cout<<endl;
    }
    else cout<<"invalid grille"<<endl;

  return 0;
}

